#!/bin/bash
# Handelt eine Session-ID mit dem Server (FritzBox) aus, diese kann dann für Anfragen verwendet werden
SERVER="fritz.box"  # funktioniert meistens
USRNAME=merkava     # bitte anpaqssen!!!
PASSWORD="XsyapfEkwlsftr23"   # bitte anpaqssen!!!
Bdir=~/Dokumente/fritzbox     # Anpassen !!!

challengeRsp=$(curl --header "Accept: application/xml" --header "Content-Type: text/plain" "http://$SERVER/login_sid.lua" 2>/dev/null)
challenge=$(echo $challengeRsp | sed "s/^.*<Challenge>//" | sed "s/<\/Challenge>.*$//")

if [[ -z $challenge ]]; then
	echo "No challenge found"
	exit 0
fi

challenge_bf="$challenge-$PASSWORD"
challenge_bf=$(printf $challenge_bf | iconv -t UTF-16LE | md5sum - | cut -c 1-32)
response_bf="$challenge-$challenge_bf"

sidRsp=$(curl --header "Accept: text/html,application/xhtml+xml,application/xml" \
	--header "Content-Type: application/x-www-form-urlencoded"		\
	-d "username=$USRNAME" \
	-d "response=$response_bf" \
	http://$SERVER/login_sid.lua 2>/dev/null)

sid=$(echo $sidRsp | sed "s/^.*<SID>//" | sed "s/<\/SID>.*$//")

regex="^0+$"
if [[ $sid =~ $regex ]]; then
	echo "Invalid password"
	exit 0
fi
FBLogout() {
curl --header "Accept: application/xml" --header "Content-Type: text/plain" -d "logout=1" -d "sid=$sid" "http://$SERVER/login_sid.lua" 2>/dev/null
echo "Sitzungs ID $sid verworfen"
}
export sid SERVER
